PROGRAM_NAME='SAMPLE'

DEFINE_DEVICE

    dvIPPort1	 			= 0:5:0;

    dvLightButtons_1			= 10002:1:0;
    dvLightButtons_2			= 10003:1:0;

    dvLightSliders_1			= 10002:2:0;
    dvLightSliders_2			= 10003:2:0;

    vdvKNX_INPUT			= 33001:1:0;
    vdvKNX_OUTPUT			= 33002:1:0;
    vdvGUI				= 33003:1:0;

DEFINE_CONSTANT

    BTN_SEND_1BIT	= 20;
    BTN_SEND_1BYTE	= 21;
    BTN_SEND_2BYTE	= 22;
    BTN_SEND_TIME	= 23;
    BTN_SEND_DATE	= 24;

DEFINE_TYPE

DEFINE_VARIABLE

    VOLATILE CHAR s_chLicenceKey[] 	= '';

    VOLATILE CHAR s_chKNX_IP_Address[] 	= '192.168.1.20';
    VOLATILE INTEGER s_uKNX_IP_Port 	= 3671;

    // LEDS STATE //
    VOLATILE CHAR s_uLINK		= 0;
    VOLATILE CHAR s_uTX			= 0;
    VOLATILE CHAR s_uRX			= 0;
    VOLATILE CHAR s_uERR		= 0;

    // DEFINE 2 PANELS //
    VOLATILE DEV s_dvLightButtons[] = {dvLightButtons_1, dvLightButtons_2};

DEFINE_LATCHING

DEFINE_MUTUALLY_EXCLUSIVE

    // DEFINE THE COMMUNICATION MODULE //
    DEFINE_MODULE 'KNXIP_BUS'	KNXCOMM (s_chLicenceKey, dvIPPort1, s_chKNX_IP_Address, s_uKNX_IP_Port, vdvKNX_INPUT, vdvKNX_OUTPUT, s_uLINK, s_uTX, s_uRX, s_uERR);

    // DEFINE THE
    DEFINE_MODULE 'KNXIP_GUI'	KNXGUI  (vdvGUI, vdvKNX_INPUT, vdvKNX_OUTPUT, s_dvLightButtons, s_uLINK, s_uTX, s_uRX, s_uERR);

DEFINE_START

    SEND_COMMAND vdvKNX_INPUT, 'DEBUG ON';

    // ADD A DIMMER //
    // FORMAT IS 'DIMMER:CHANNEL':ACTIVATION GROUP:STATUS GROUP: DIM GROUP: BRIGHTNESS SET: BRIGHTNESS STATUS //
    SEND_STRING vdvGUI, "'DIMMER:11:0/1/1:7/1/1:1/1/1:2/1/1:2/1/1'";
    SEND_STRING vdvGUI, "'DIMMER:12:0/1/2:7/1/2:1/1/2:2/1/2:2/1/2'";
    SEND_STRING vdvGUI, "'DIMMER:13:0/1/3:7/1/3:1/1/3:2/1/3:2/1/3'";
    SEND_STRING vdvGUI, "'DIMMER:14:0/1/4:7/1/4:1/1/4:2/1/4:2/1/4'";

    // ADD A SWITCH //
    // FORMAT IS 'SWITCH:CHANNEL':ACTIVATION GROUP:STATUS GROUP //
    SEND_STRING vdvGUI, "'SWITCH:15:0/1/1:7/1/1'";

    // AS OFF AND ON ONLY //
    // FORMAT IS 'OFFONLY:CHANNEL':ACTIVATION GROUP:STATUS GROUP //
    SEND_STRING vdvGUI, "'ONONLY:16:0/1/1:7/1/1'";
    SEND_STRING vdvGUI, "'OFFONLY:17:0/1/1:7/1/1'";

    // ADD LEVEL SET //
    // FORMAT IS 'SETLEVEL:CHANNEL':BRIGHTNESS SET:STATUS GROUP //
    SEND_STRING vdvGUI, "'SETLEVEL:18:2/1/1:7/1/1:128'";

    // A DATE IS A 3 BYTE TYPE, THE MODULE WILL NEED TO KNOW IF ITS TO BE TRANSLATED INTO A DATE OR A TIME //
    // ADD DATE //
    // FORMAT IS 'DATE:DATE GROUP'//
    SEND_STRING vdvKNX_INPUT, "'T12/1/2:PDT_DATE'";

    // A TIME IS A 3 BYTE TYPE, THE MODULE WILL NEED TO KNOW IF ITS TO BE TRANSLATED INTO A DATE OR A TIME //
    // ADD TIME //
    // FORMAT IS 'DATE:DATE GROUP'//
    SEND_STRING vdvKNX_INPUT, "'T12/1/1:PDT_TIME'";



    SEND_STRING vdvKNX_INPUT, "'TIMESTAMP:12/1/1:STARTUP MINUTE'";
    SEND_STRING vdvKNX_INPUT, "'DATESTAMP:12/1/2:STARTUP HOUR'";
DEFINE_EVENT


    // THESE 3 BUTTONS SEND VARIOUS DATA TYPES //
    BUTTON_EVENT[s_dvLightButtons, BTN_SEND_1BIT]
    BUTTON_EVENT[s_dvLightButtons, BTN_SEND_1BYTE]
    BUTTON_EVENT[s_dvLightButtons, BTN_SEND_2BYTE]
    BUTTON_EVENT[s_dvLightButtons, BTN_SEND_TIME]
    BUTTON_EVENT[s_dvLightButtons, BTN_SEND_DATE]
    {
	PUSH:
	{
	    SWITCH(BUTTON.INPUT.CHANNEL)
	    {
		CASE BTN_SEND_1BIT:
		{
		    SEND_STRING vdvKNX_INPUT, "'W10/1/001=1:DPT_6BIT'";
		}
		CASE BTN_SEND_1BYTE:
		{
		    SEND_STRING vdvKNX_INPUT, "'W10/1/001=1:DPT_1BYTE'";
		}
		CASE BTN_SEND_2BYTE:
		{
		    SEND_STRING vdvKNX_INPUT, "'W10/1/001=-30.5:DPT_2BYTE'";
		    SEND_STRING vdvKNX_INPUT, "'W10/1/001=30.5:DPT_2BYTE'";
		}
		CASE BTN_SEND_TIME:
		{
		    SEND_STRING vdvKNX_INPUT, "'W12/1/001=', ITOA(TIME_TO_HOUR(TIME)), ':', ITOA(TIME_TO_MINUTE(TIME)), ':', ITOA(TIME_TO_SECOND(TIME)),':DPT_3BYTE'";
		}
		CASE BTN_SEND_DATE:
		{
		    SEND_STRING vdvKNX_INPUT, "'W12/1/002=', ITOA(DATE_TO_YEAR(LDATE)), '-', ITOA(DATE_TO_MONTH(DATE)), '-', ITOA(DATE_TO_DAY(DATE)),':DPT_3BYTE'";
		}
	    }
	}
    }

DEFINE_PROGRAM




